- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnDistanceManip Class Reference

# OpenMayaUI - API module for user interface | FunctionSet classes

Search for all occurrences

## Detailed Description

DistanceManip function set.

The DistanceManip allows the user to manipulate a point that is constrained to move along a line. This manipulator generates a single floating point value. Scaling factors can be used to determine how int the manipulator appears when it is drawn.

Examples:

  footPrintManip.cpp, moveManip.cpp, and swissArmyManip.cpp.

`#include <MFnDistanceManip.h>`

Inheritance diagram for MFnDistanceManip:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnDistanceManip ()
| Destructor.
| MFnDistanceManip ()
| Default constructor.
| MFnDistanceManip (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
| MFnDistanceManip (const MDagPath &object, MStatus *ret=NULL)
| Constructor.
MObject | create (MStatus *ReturnStatus=NULL)
| Creates a new DistanceManip.
MObject | create (const MString &manipName, const MString &distanceName, MStatus *ReturnStatus=NULL)
| Creates a new DistanceManip.
MStatus | connectToDistancePlug (MPlug &distancePlug)
| Connect to the distance plug.
MStatus | setStartPoint (const MPoint &point)
| Sets the start point of the DistanceManip.
MStatus | setDirection (const MVector &vector)
| Sets the direction of the DistanceManip.
MStatus | setDrawStart (bool state)
| Sets whether or not to draw the start of the DistanceManip.
MStatus | setDrawLine (bool state)
| Sets whether or not to draw a line from the start to the end of the DistanceManip.
MStatus | setScalingFactor (double scalingFactor)
| Sets the scaling factor.
bool | isDrawStartOn (MStatus *ReturnStatus=NULL) const
| Returns whether or not the start of the DistanceManip is being drawn.
bool | isDrawLineOn (MStatus *ReturnStatus=NULL) const
| Returns whether or not a line is being drawn from the start to the end of the DistanceManip.
double | scalingFactor (MStatus *ReturnStatus=NULL) const
| Returns the scaling factor.
unsigned int | distanceIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the distance.
unsigned int | directionIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the direction.
unsigned int | startPointIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the start point of the DistanceManip.
unsigned int | currentPointIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the current point of the DistanceManip.
| MFnDistanceManip (const MObject &object, MStatus *ret=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

~MFnDistanceManip | ( |  | ) | `[virtual]`

Destructor.

Class destructor.

MFnDistanceManip | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnDistanceManip | ( | const MDagPath & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given constant MDagPath object.

Parameters:

  [in] | object | The const MDagPath to attach the function set to
  [out] | ReturnStatus | The return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnDistanceManip | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kDistanceManip.

Reimplemented from MFnManip3D.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnDistanceManip".

Reimplemented from MFnManip3D.

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Creates a new DistanceManip.

This function set's object is set to be the new manipulator.

This method should only be used to create a non-composite DistanceManip.

The name that appears in the feedback line is "Distance"

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Newly created DistanceManip

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MObject create | ( | const MString & | manipName,
|  | const MString & | distanceName,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new DistanceManip.

This function set's object is set to be the new manipulator.

This method should only be used to create a non-composite DistanceManip.

The name that appears in the feedback line is specified by the distanceName argument.

Parameters:

  [in] | manipName | Name of the manip for UI purposes.
  [in] | distanceName | Label for the distance value which appears in the feedback line.
  [out] | ReturnStatus | Status code.

Returns:
  Newly created DistanceManip.

Status Codes:
  - MS::kSuccess Operation successful.
  - MS::kFailure Operation failed.

Reimplemented from MFnDependencyNode.

MStatus connectToDistancePlug | ( | MPlug & | distancePlug | ) |

Search for all occurrences

Connect to the distance plug.

The data type corresponding to the distancePlug is a double. (Note that MFnUnitAttribute::kDistance is used to specify a distance attribute.)

Parameters:

  [in] | distancePlug | the distance plug

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

Examples:
  swissArmyManip.cpp.

MStatus setStartPoint | ( | const MPoint & | startPoint | ) |

Search for all occurrences

Sets the start point of the DistanceManip.

Parameters:

  [in] | startPoint | the start point of the DistanceManip

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setDirection | ( | const MVector & | direction | ) |

Search for all occurrences

Sets the direction of the DistanceManip.

Parameters:

  [in] | direction | the direction of the DistanceManip

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setDrawStart | ( | bool | state | ) |

Search for all occurrences

Sets whether or not to draw the start of the DistanceManip.

The start of the DistanceManip is indicated by a grey dot. By default the start is not drawn.

Parameters:

  [in] | state | whether or not the start should be drawn

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setDrawLine | ( | bool | state | ) |

Search for all occurrences

Sets whether or not to draw a line from the start to the end of the DistanceManip.

By default the line is drawn.

Parameters:

  [in] | state | whether or not the line should be drawn

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setScalingFactor | ( | double | scalingFactor | ) |

Search for all occurrences

Sets the scaling factor.

The scaling factor is used to determine how int the DistanceManip appears when it is drawn. The default scaling factor is 1.0.

Parameters:

  [in] | scalingFactor | the scaling factor

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

bool isDrawStartOn | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns whether or not the start of the DistanceManip is being drawn.

By default the start is not drawn.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  - true the start of the DistanceManip is being drawn
  - false the start of the DistanceManip is not being drawn

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

bool isDrawLineOn | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns whether or not a line is being drawn from the start to the end of the DistanceManip.

By default the line is drawn.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  - true the line of the DistanceManip is being drawn
  - false the line of the DistanceManip is not being drawn

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

double scalingFactor | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the scaling factor.

The scaling factor is used to determine how int the DistanceManip appears when it is drawn.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Scaling factor

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int distanceIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the distance.

The data type corresponding to this index is a double.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Distance index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int directionIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the direction.

The data type corresponding to this index is MFnNumericData::k3Double.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Direction index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int startPointIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the start point of the DistanceManip.

The data type corresponding to this index is MFnNumericData::k3Double.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Start point index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

Examples:
  swissArmyManip.cpp.

unsigned int currentPointIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the current point of the DistanceManip.

The data type corresponding to this index is MFnNumericData::k3Double.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Current point index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip
MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip MFnDistanceManip